; wertstahl ist ein metallmann (c) 2015,2016,2017

*=$0801
            byte  $0c,$08,$01,$00,$9e,$20,$32,$30,$36,$32,$00,$00,$00; 0 sys2062 ($080e)

*=$080e
            jmp   appstart

;-------------------------------------------------------------------------------------

appstart    cld
            sei

            jsr   killl

            lda   #$3b        ;bitmap mode on
            sta   $d011       
            lda   #$c8        
            sta   $d016       ;single color

            lda   #%00011000  
            sta   $d018       ;bitmap @ 2000
            
            lda   #$00
            sta   $d020       

            ;-----------------------------
            
ristart     lda   #$20        ;target area   
            sta   $fd    
            lda   #$00        
            sta   $fc         
            
            lda   #$1f        ;readout area that lies 32 bytes before the output buffer for constant audio sample replay
            sta   $fb         
            lda   #$e0        
            sta   $fa         
                        
            lda   #$d8        
            sta   $ff
            lda   $d012       ;random start position for readout
            sta   $fe
        
            ;-----------------------------

idle        lda   #$00
            sta   $02
            ldx   #$07
            ldy   $d012       ;sub-randomize readout position

bitassemble lda   ($fe),y
            and   #$80
            ora   $02         
            lsr
            sta   $02         
            tay
            
            dex
            bne   bitassemble 
            
            lda   ($fe),y
            and   #$80
            ora   $02         
            sta   $02
        
            ;create tiny loop counter in y
            ldy   #$00

            ;while waiting use the last printed y bytes as audio sample content
vmini       lda   ($fa),y     ;betterer ;-) strategy using own mempointer
            sta   $d418       

            lsr
            lsr
            lsr
            lsr
            lsr
            lsr
            lsr
         
            asl
            asl
            asl
            sta   $03

            lda   $d016
            and   #%11110111            
            ora   $03         
            sta   $d016  
      
            lda   $d011       
            and   #%11110111
            inc   $d011  
            ora   $03         
            sta   $d011
                       
            ;check for spacebar in case we need to reset
            lda   $dc01       
            and   #%00010000
            beq   resetthis   ;start over if space is pressed

            ;store assembled byte in bitmap
            ldy   #$00
            lda   ($fc),y       
            eor   $02
            sta   ($fc),y

            ;advance target area lowbyte
            inc   $fc    
            bne   shmidle        

            ;advance target area hibyte with max of $3fff
            inc   $fd    
            lda   $fd    
            cmp   #$40        
            bne   shmidle        

            jmp   ristart     ;reset mem pointers

shmidle     inc   $fa
            bne   shmidle2    ;no catch or reset here, we just read from these, reset will be controlled by write pointer
            inc   $fb

shmidle2    jmp   idle

resetthis   inc   $d020
            jmp   appstart
       
eqstor      byte  0
eqstor2     byte  0
storbit     byte  0

;---------------------------------------------------

clscol      = #$00
clschar     = #$e6
            
killl       ldy   #$00        ; clear screen & color

clr         lda   clschar
            sta   $0400,y     
            sta   $0500,y
            sta   $0600,y
            sta   $06e8,y     
            
            lda   #$00  
     
            sta   $d800,y     
            sta   $d900,y     
            sta   $da00,y     
            sta   $db00,y     

            iny
            cpy   #$00
            bne   clr         
            rts
            
;--------------------------------------------------

;eof